package exnihilocreatio.blocks;

import exnihilocreatio.config.Config;
import exnihilocreatio.items.ItemMesh;
import exnihilocreatio.tiles.TileSieve;
import exnihilocreatio.util.Util;
import mcjty.theoneprobe.api.IProbeHitData;
import mcjty.theoneprobe.api.IProbeInfo;
import mcjty.theoneprobe.api.IProbeInfoAccessor;
import mcjty.theoneprobe.api.ProbeMode;
import net.minecraft.block.ITileEntityProvider;
import net.minecraft.block.material.Material;
import net.minecraft.block.properties.PropertyEnum;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.client.resources.I18n;
import net.minecraft.enchantment.Enchantment;
import net.minecraft.enchantment.EnchantmentHelper;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.IStringSerializable;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.text.TextFormatting;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import net.minecraftforge.common.util.FakePlayer;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import javax.annotation.Nonnull;
import java.util.ArrayList;
import java.util.Map;

public class BlockSieve extends BlockBase implements ITileEntityProvider, IProbeInfoAccessor {

    public static final PropertyEnum<MeshType> MESH = PropertyEnum.func_177709_a("mesh", MeshType.class);

    public BlockSieve() {
        super(Material.field_151575_d, "block_sieve");
        this.func_149711_c(2.0f);
        this.func_180632_j(this.field_176227_L.func_177621_b().func_177226_a(MESH, MeshType.NO_RENDER));
    }

    @Override
    public boolean func_180639_a(World world, BlockPos pos, IBlockState state, EntityPlayer player, EnumHand hand, EnumFacing side, float hitX, float hitY, float hitZ) {
        if (world.field_72995_K)
            return true;

        // I think this should work. Let's just go with it.
        if (player instanceof FakePlayer && !Config.fakePlayersCanSieve) {
            return false;
        }

        ItemStack heldItem = player.func_184586_b(hand);
        TileSieve te = (TileSieve) world.func_175625_s(pos);

        if (te != null) {
            if (!heldItem.func_190926_b() && heldItem.func_77973_b() instanceof ItemMesh) {
                //Adding a mesh.
                ItemStack meshStack = heldItem.func_77946_l();
                meshStack.func_190920_e(1);
                boolean done = te.setMesh(meshStack, false);

                if (done) {
                    if (!player.func_184812_l_())
                        heldItem.func_190918_g(1);
                    return true;
                }
            }
            if (heldItem.func_190926_b() && !te.getMeshStack().isEmpty() && player.func_70093_af() && te.setMesh(ItemStack.field_190927_a, true)) {
                //Removing a mesh.
                Util.dropItemInWorld(te, player, te.getMeshStack(), 0.02f);
                te.setMesh(ItemStack.field_190927_a, false);
                return true;
            }

            if (te.addBlock(heldItem)) {
                if (!player.func_184812_l_())
                    heldItem.func_190918_g(1);

                for (int xOffset = -1 * Config.sieveSimilarRadius; xOffset <= Config.sieveSimilarRadius; xOffset++) {
                    for (int zOffset = -1 * Config.sieveSimilarRadius; zOffset <= Config.sieveSimilarRadius; zOffset++) {
                        TileEntity entity = world.func_175625_s(pos.func_177982_a(xOffset, 0, zOffset));
                        if (entity != null && entity instanceof TileSieve) {
                            TileSieve sieve = (TileSieve) entity;

                            if (!heldItem.func_190926_b() && te.isSieveSimilarToInput(sieve)) {
                                if (sieve.addBlock(heldItem) && !player.func_184812_l_()) {
                                    heldItem.func_190918_g(1);
                                }
                            }
                        }
                    }
                }
                return true;
            }

            ArrayList<BlockPos> toSift = new ArrayList<>();
            for (int xOffset = -1 * Config.sieveSimilarRadius; xOffset <= Config.sieveSimilarRadius; xOffset++) {
                for (int zOffset = -1 * Config.sieveSimilarRadius; zOffset <= Config.sieveSimilarRadius; zOffset++) {
                    TileEntity entity = world.func_175625_s(pos.func_177982_a(xOffset, 0, zOffset));
                    if (entity != null && entity instanceof TileSieve) {
                        TileSieve sieve = (TileSieve) entity;

                        if (te.isSieveSimilar(sieve))
                            toSift.add(pos.func_177982_a(xOffset, 0, zOffset));
                    }
                }
            }
            for (BlockPos posIter : toSift) {
                if (posIter != null) {
                    TileSieve sieve = (TileSieve) world.func_175625_s(posIter);

                    if (sieve != null) {
                        sieve.doSieving(player, false);
                    }
                }
            }
            return true;
        }

        return true;
    }

    @Override
    @Nonnull
    protected BlockStateContainer func_180661_e() {
        return new BlockStateContainer(this, MESH);
    }

    @Override
    @Nonnull
    @Deprecated
    public IBlockState func_176203_a(int meta) {
        return func_176223_P();
    }

    @Override
    public int func_176201_c(IBlockState state) {
        return 0;
    }

    @Override
    public void func_180663_b(@Nonnull World world, @Nonnull BlockPos pos, @Nonnull IBlockState state) {
        TileEntity te = world.func_175625_s(pos);
        if (te != null) {
            TileSieve sieve = (TileSieve) te;
            if (!sieve.getMeshStack().isEmpty())
                Util.dropItemInWorld(sieve, null, sieve.getMeshStack(), 0.02f);
        }

        super.func_180663_b(world, pos, state);
    }


    @Override
    public TileEntity func_149915_a(@Nonnull World worldIn, int meta) {
        return new TileSieve();
    }

    //region >>>> RENDERING OPTIONS
    @Override
    @Deprecated
    public boolean func_149730_j(IBlockState state) {
        return false;
    }

    @Override
    @Deprecated
    public boolean func_149662_c(IBlockState state) {
        return false;
    }

    @Override
    @Deprecated
    public boolean func_149686_d(IBlockState state) {
        return false;
    }

    @Override
    public boolean func_176225_a(IBlockState blockState, IBlockAccess blockAccess, BlockPos pos, EnumFacing side) {
        return false;
    }
    //endregion

    @Override
    @SideOnly(Side.CLIENT)
    public void addProbeInfo(ProbeMode mode, IProbeInfo probeInfo, EntityPlayer player, World world,
                             IBlockState blockState, IProbeHitData data) {

        TileSieve sieve = (TileSieve) world.func_175625_s(data.getPos());
        if (sieve == null)
            return;

        if (sieve.getMeshStack().isEmpty()) {
            probeInfo.text("Mesh: None");
            return;
        }
        probeInfo.text("Mesh: " + I18n.func_135052_a(sieve.getMeshStack().getUnlocalizedName() + ".name"));

        if (mode == ProbeMode.EXTENDED) {
            Map<Enchantment, Integer> enchantments = EnchantmentHelper.func_82781_a(sieve.getMeshStack());
            for (Map.Entry<Enchantment, Integer> enchantment : enchantments.entrySet()) {
                probeInfo.text(TextFormatting.BLUE + enchantment.getKey().func_77316_c(enchantment.getValue()));
            }
        }

    }

    public enum MeshType implements IStringSerializable {
        NONE(0, "none"), STRING(1, "string"), FLINT(2, "flint"), IRON(3, "iron"), DIAMOND(4, "diamond"), NO_RENDER(5, "no_render");

        private int id;
        private String name;

        MeshType(int id, String name) {
            this.id = id;
            this.name = name;
        }

        public static MeshType getMeshTypeByID(int meta) {
            switch (meta) {
                case 1:
                    return STRING;
                case 2:
                    return FLINT;
                case 3:
                    return IRON;
                case 4:
                    return DIAMOND;
                case 5:
                    return NO_RENDER;
            }

            return NONE;
        }

        @Override
        @Nonnull
        public String func_176610_l() {
            return name;
        }

        public int getID() {
            return id;
        }

        @Override
        public String toString() {
            return func_176610_l();
        }
    }

}
